#include "papu_decayunit.hh"
#include "papu_lengthunit.hh"
class randgenunit : public decayunit, public lengthunit
{
    fWORD wavelen;
    bool randmode;  // false = 32767-bit, true = 93-bit
    WORD shiftreg;
    fWORD wavepos;
public:
    fBYTE output;
public:
    randgenunit() : wavelen(0), shiftreg(0x0001), wavepos(0), output(0)
    {
    }
    
    void write(fBYTE ind, fBYTE value);

    EMPTY_HZTICKER(120);
    
    inline bool silent() const
    {
        return lengthunit_silent();
    }
    BEGIN_WAVETICKER
        if(!silent())
        {
            output = ~((shiftreg >> 14) ^ (shiftreg >> (randmode ? 8 : 13))) & 1;
            shiftreg = (shiftreg << 1) | output;
        }
    END_WAVETICKER
    
    void debug_silence()
    {
    	fprintf(stderr, "%sabled", chanenabled?"en":"dis");
    	fprintf(stderr, ";shiftreg=");
    	for(unsigned a=15; a>0; )fprintf(stderr, "%d", (shiftreg>>--a)&1);
    	fprintf(stderr, ",result=%d,wlen=%u,bits=%d",
    		output, wavelen, randmode?93:32767);
    	decayunit::debug_silence();
	    lengthunit::debug_silence();
    }
};
