#include "papu_waveunit.hh"
#include "papu_decayunit.hh"
#include "papu_lengthunit.hh"
class squaregenunit : public waveunit, public lengthunit, public decayunit
{
    fBYTE sweepdata;
    fBYTE sweeppos;
    fBYTE sweepspeed;
    fBYTE sweepshift;
    bool sweepenabled;
    bool jammed;
    fBYTE decr;
public:
    fBYTE dutytype;
    fBYTE dutycounter;
public:
    squaregenunit() : sweeppos(0), sweepspeed(0), sweepenabled(false), jammed(false), decr(0), dutytype(0)
    { 
    }
    inline void set_decr_mode(fBYTE d) { decr = d; }
    
    void write(fBYTE ind, fBYTE value);

    DEFINE_HZTICKER(120);
    inline bool silent() const
    {
        return jammed || lengthunit_silent();
    }
    BEGIN_WAVETICKER
        /*if(!silent())*/ ++dutycounter;
    END_WAVETICKER
    
    void debug_silence()
    {
    	fprintf(stderr, "%sabled", chanenabled?"en":"dis");
    	fprintf(stderr, "; wlen=%u, sweep(shift %d %s, rate %d, %sabled)",
    		wavelen,
    		sweepshift, (sweepdata&8)?"down":"up", (sweepdata&7), sweepenabled?"en":"dis");
    	decayunit::debug_silence();
	    lengthunit::debug_silence();
    }
};
