#include "papu_waveunit.hh"
#include "papu_lengthunit.hh"
class triangleunit : public waveunit, public lengthunit
{
    enum {triload, tricount} trimode;
    fBYTE linearcounter, triloadvalue;
    bool oldbit;
    bool jammed;
public:
    fBYTE trianglecounter;
public:
    triangleunit() : lengthunit(7), trimode(triload), linearcounter(0),
                     triloadvalue(0), oldbit(false), jammed(false), trianglecounter(0)
    {
    }
    
    void write(fBYTE ind, fBYTE value);

    EMPTY_HZTICKER(120);
	DEFINE_HZTICKER(240);
	
    inline bool silent() const
    {
        return jammed || lengthunit_silent();
    }
    
    BEGIN_WAVETICKER
        /*if(!silent())*/ ++trianglecounter;
    END_WAVETICKER

    void debug_silence()
    {
    	fprintf(stderr, "%sabled", chanenabled?"en":"dis");
    	fprintf(stderr, "; wlen=%u", wavelen);
    	lengthunit::debug_silence();
    }
};